//
//  ViewController.swift
//  CodeDemo
//
//  Created by wangdong on 2019/4/25.
//  Copyright © 2019 wangdong. All rights reserved.
//

import UIKit

class ViewController: UIViewController {

    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        let cview = CodeView(width: 33, pore: 5, num: 7)
        view.addSubview(cview)
        cview.center = view.center
        cview.font = UIFont.boldSystemFont(ofSize: 16)
//        cview.layer.borderColor = UIColor.cyan.cgColor
//        cview.layer.borderWidth = 1
        
        let tf = UITextField(frame: CGRect(x: 0, y: 0, width: 200, height: 44))
        view.addSubview(tf)
        tf.center = CGPoint(x: self.view.center.x, y: self.view.center.y+66)
        tf.layer.borderColor = UIColor.blue.cgColor
        tf.layer.borderWidth = 1
        tf.autocorrectionType = .no
        
    }
}

extension ViewController {
    class CodeView: UIView, UITextFieldDelegate {
        private class TextField: UITextField {
            override func canPerformAction(_ action: Selector, withSender sender: Any?) -> Bool {
                //print(action)
                //print(value(forKey: "_floatingContentView") ?? "_floatingContentView = nil")
                return false
            }
        }
        private var _baiscTag = 6666
        private var _maxLen: Int = 0
        private var _width: CGFloat = 0.0
        private var _pore: CGFloat = 0.0
        private var _tf: TextField!
        var maxLen: Int {
            return _maxLen
        }
        var text: String? {
            return _tf.text
        }
        var font: UIFont {
            set {
                for i in 0..<_maxLen {
                    let l = viewWithTag(_baiscTag+i+1) as! UILabel
                    l.font = newValue
                }
            } get {
                let l = viewWithTag(_baiscTag+1) as! UILabel
                return l.font
            }
        }
        var textColor: UIColor {
            set {
                for i in 0..<_maxLen {
                    let l = viewWithTag(_baiscTag+i+1) as! UILabel
                    l.textColor = newValue
                }
            } get {
                let l = viewWithTag(_baiscTag+1) as! UILabel
                return l.textColor
            }
        }
        private override init(frame: CGRect) {
            super.init(frame: frame)
        }
        required init?(coder aDecoder: NSCoder) {
            fatalError("init(coder:) has not been implemented")
        }
        convenience init(width: CGFloat, pore: CGFloat, num: UInt) {
            let w = width * CGFloat(num) + pore * CGFloat(num-1)
            self.init(frame: CGRect(x: 0, y: 0, width: w, height: width))
            _maxLen = Int(num)
            _width = width
            _pore = pore
            setupSubviews()
        }
        func updateOriginPoint(_ op: CGPoint) {
            var f = frame
            f.origin = op
            frame = f
        }
        func setupSubviews() {
            for i in 0..<_maxLen {
                let frame = CGRect(x: CGFloat(i) * (_width+_pore), y: 0, width: _width, height: _width)
                let label = UILabel(frame: frame)
                addSubview(label)
                label.layer.borderWidth = 1
                label.layer.borderColor = UIColor.gray.cgColor
                label.layer.cornerRadius = 2
                label.layer.masksToBounds = true
                label.tag = _baiscTag + i + 1
                label.textAlignment = .center
            }
            
            _tf = TextField(frame: bounds)
            addSubview(_tf)
            _tf.autocorrectionType = .no // 禁止键盘联想 or 禁止键盘推荐
            _tf.tintColor = .clear
            _tf.setValue(UIColor.clear, forKeyPath: "textInputTraits.insertionPointColor")
            _tf.backgroundColor = .clear
            _tf.textColor = .clear
            _tf.frame = bounds
            _tf.delegate = self
            _tf.tag = _baiscTag
            _tf.textInputView.backgroundColor = .clear
            _tf.addTarget(self, action: #selector(textFieldTextChanged), for: .editingChanged)
        }
        @objc func textFieldTextChanged() {
            if let _ = _tf.markedTextRange {
                // 支持中文输入
                return
            }
            var txt = _tf.text ?? ""
            var str = txt.map(String.init)
            if str.count > _maxLen {
                str = str[0..<_maxLen].map { $0 }
            }
            //print(str)
            txt = str.joined(separator: "")
            _tf.text = txt
            for i in 0..<_maxLen {
                let l = viewWithTag(_baiscTag+i+1) as! UILabel
                if (i < txt.count) {
                    let startIndex = txt.index(txt.startIndex, offsetBy: i)
                    l.text = String(txt[startIndex])
                } else {
                    l.text = ""
                }
            }
        }
        func textField(_ textField: UITextField, shouldChangeCharactersIn range: NSRange, replacementString string: String) -> Bool {
            return true
        }
    }
}

